require_relative 'player'

module StudioGame
  class ClumsyPlayer < Player

    attr_accessor :boost_factor

    def initialize(name, health, boost_factor=0)
      super(name, health)
      @boost_factor = boost_factor
    end

    def found_treasure(treasure)
      super(Treasure.new(treasure.name, treasure.points / 2.0))
    end

    def w00t
      @boost_factor.times {super}
    end

  end


  if __FILE__ == $0
    klutz = ClumsyPlayer.new("klutz", 105)
    klutz.found_treasure(Treasure.new(:hammer, 50))
    klutz.found_treasure(Treasure.new(:hammer, 50))
    klutz.found_treasure(Treasure.new(:hammer, 50))
    klutz.found_treasure(Treasure.new(:crowbar, 400))

    klutz.each_found_treasure do |treasure|
      puts "#{treasure.points} total #{treasure.name} points."
    end
    puts "\n#{klutz.points} grand total points."
  end
end
